// GetTMLinkDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GetTMLink.h"
#include "GetTMLinkDlg.h"
#include ".\gettmlinkdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CGetTMLinkDlg dialog



CGetTMLinkDlg::CGetTMLinkDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGetTMLinkDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGetTMLinkDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CGetTMLinkDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
END_MESSAGE_MAP()


// CGetTMLinkDlg message handlers

BOOL CGetTMLinkDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	CoInitialize(NULL);
	
	TCHAR sPath[MAX_NAME];
	if(!FAILED(GetLinkPath(sPath)))
		GetDlgItem(IDC_LINK_PATH)->SetWindowText(sPath);
	else
		GetDlgItem(IDC_LINK_PATH)->SetWindowText(_T("Sorry! Either you do not have Turbomeeting installed on this PC or Some Error had occured"));

	CoUninitialize();
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGetTMLinkDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGetTMLinkDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CGetTMLinkDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}


HRESULT CGetTMLinkDlg::GetLinkPath(LPTSTR sTargetPath)
{
	TCHAR sShortcutPath[MAX_NAME];
	TCHAR sPath[MAX_PATH]; 
	WIN32_FIND_DATA uWindowsData; 
	
	HRESULT hr = CoInitializeEx(NULL, COINIT_APARTMENTTHREADED);
	if(FAILED(hr))
	{
		CoUninitialize();
		return hr;
	}
	sTargetPath[0] = '\0';
	if(IsRunningVista())
	{
		if(!SHGetSpecialFolderPath( NULL,sShortcutPath,CSIDL_COMMON_PROGRAMS,FALSE))
			return E_FAIL;
	}
	else
	{
		if(!SHGetSpecialFolderPath( NULL,sShortcutPath,CSIDL_PROGRAMS,FALSE))
			return E_FAIL;
	}
	_tcscat(sShortcutPath,_T("\\TurboMeeting\\Start Meeting.lnk"));
	HRESULT hResult = E_FAIL;
	CComPtr<IShellLink> ipShellLink;
	hResult = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER,IID_IShellLink,(void**)&ipShellLink); 
	if (SUCCEEDED(hResult)) 
	{ 
		CComQIPtr<IPersistFile> ipPersistFile(ipShellLink);
		WCHAR wsTemporary[MAX_PATH];
		#if !defined _UNICODE
			MultiByteToWideChar(CP_ACP, 0, sShortcutPath,-1, wsTemporary, MAX_PATH);
		#else
			wcsncpy(wsTemporary, sShortcutPath, MAX_PATH);
		#endif
		hResult = ipPersistFile->Load(wsTemporary, STGM_READ); 
		if (SUCCEEDED(hResult)) 
		{
			hResult = ipShellLink->Resolve(NULL, SLR_UPDATE); 
			if (SUCCEEDED(hResult)) 
			{
				hResult = ipShellLink->GetPath(sPath, MAX_PATH, &uWindowsData, SLGP_RAWPATH); 
				if (FAILED(hResult))
					return hResult;
				lstrcpyn(sTargetPath, sPath, MAX_PATH); 

			}	 

		}	 

	} 
	
	CoUninitialize();
	return hResult;
}

bool CGetTMLinkDlg::IsRunningVista()
{

	#ifdef _WIN32

		OSVERSIONINFOEX osvi;
		ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
		osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
		if(!GetVersionEx((OSVERSIONINFO*)&osvi))
		{
			osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
			if(!GetVersionEx((OSVERSIONINFO*)&osvi))
				return false;
		}

		if( osvi.dwPlatformId == VER_PLATFORM_WIN32_NT && 
	osvi.dwMajorVersion > 5 )
			return true;

		return false;

	#else
		return false;

	#endif
}